import java.applet.Applet;
import java.awt.*;
import java.net.*;
import java.io.*;

public class EX17B extends Applet
{
    TextField prodName;
    TextArea prodInfo;
    Button search;
    Label status;
    URL url;

    public void init()
    {
        prodName = new TextField(30);
        prodInfo = new TextArea(10, 30);
        prodInfo.setEditable(false);
        search = new Button("Search");
        status = new Label();
        Label l;

        GridBagLayout gbag = new GridBagLayout();
        GridBagConstraints cons = new GridBagConstraints();
        cons.insets = new Insets(5, 5, 5, 5);

        setLayout(gbag);

        l = new Label("World Distributors Product Information");
        l.setFont(new Font("Helvetica", Font.BOLD, 18));
        cons.gridwidth = GridBagConstraints.REMAINDER;
        gbag.setConstraints(l, cons);
        add(l);

        cons.anchor = GridBagConstraints.NORTHWEST;
        cons.gridwidth = 1;
        l = new Label("Product Name:");
        gbag.setConstraints(l, cons);
        add(l);

        cons.fill = GridBagConstraints.HORIZONTAL;
        gbag.setConstraints(prodName, cons);
        add(prodName);

        cons.fill = GridBagConstraints.NONE;
        cons.gridwidth = GridBagConstraints.REMAINDER;
        gbag.setConstraints(search, cons);
        add(search);

        cons.fill = GridBagConstraints.HORIZONTAL;
        gbag.setConstraints(status, cons);
        add(status);

        l = new Label("Product Information:");
        gbag.setConstraints(l, cons);
        add(l);

        cons.fill = GridBagConstraints.BOTH;
        gbag.setConstraints(prodInfo, cons);
        add(prodInfo);

        resize(300, 400);
    }

    public boolean handleEvent(Event evt)
    {
        if (evt.target == search)
        {
            if (prodName.getText().length() > 0)
                search();
            else
                status.setText("Please enter a product name.");
            return true;
        }
        else
            return super.handleEvent(evt);
    }

    public void start()
    {
        try
            url = new URL("http", getCodeBase().getHost(), getParameter("SCRIPT"));
        catch (MalformedURLException e)
        {
            status.setText("Error initializing URL to server.");
            url = null;
        }
    }

    public void search()
    {
        if (url == null)
        {
            status.setText("Unknown URL; cannot perform query.");
            return;
        }

        try
        {
            status.setText("Querying server...");
            URLConnection conn = url.openConnection();

            PrintStream os = new PrintStream(conn.getOutputStream());
            os.println(URLEncoder.encode(prodName.getText()));
            os.close();

            status.setText("Retrieving response...");
            DataInputStream is = new DataInputStream(conn.getInputStream());

            String line = is.readLine();
            prodInfo.setText("");

            while (line != null)
            {
                prodInfo.appendText(line + "\n");
                line = is.readLine();
            }
            is.close();
            status.setText("");
        }
        catch (IOException e)
        {
            status.setText("Error processing query: " + e);
        }
    }
}
